within ;
model Model26042019_CO25bar

  inner TIL.SystemInformationManager sim(redeclare
      TILMedia.VLEFluidTypes.TILMedia_CO2 vleFluidType1, redeclare
      TILMedia.VLEFluidTypes.BaseVLEFluid vleFluidType2(
      fixedMixingRatio=false,
      nc_propertyCalculation=1,
      vleFluidNames={"Refprop.HYDROGEN.FLD"},
      mixingRatio_propertyCalculation={1}))   annotation (Placement(transformation(extent={{40,40},
            {60,60}},         rotation=0)));

  TIL.VLEFluidComponents.PressureStateElements.PressureState pressureState1(
    pressureStateID=1, pInitial=500000)
                               annotation (Placement(transformation(extent={{-70,-42},
            {-58,-30}},       rotation=0)));
  TIL.VLEFluidComponents.PressureStateElements.PressureState pressureState2(
    pressureStateID=2,
    vleFluidType=sim.vleFluidType2,
    pInitial=35000000)
                      annotation (Placement(transformation(
        origin={48,6},
        extent={{6,6},{-6,-6}},
        rotation=180)));
  TIL.VLEFluidComponents.Boundaries.BoundaryOverdetermined boundary_a_source(
    boundaryType="p, m_flow",
    use_pressureInput=false,
    pFixed=pressureState1.pInitial,
    hFixed=199e3,
    streamVariablesInputType="h",
    use_massFlowRateInput=false,
    TFixed=227.15,
    m_flowFixed=-0.35)
                      annotation (Placement(transformation(extent={{-84,-46},{
            -76,-26}},
                     rotation=0)));
  TIL.VLEFluidComponents.Boundaries.BoundaryUnderdetermined boundary_a_sink(
    streamVariablesInputType="h",
    hFixed=499e3,
    TFixed=303.15)
    annotation (Placement(transformation(extent={{54,-48},{62,-28}},
                                                                   rotation=0)));
  TIL.VLEFluidComponents.Boundaries.BoundaryOverdetermined boundary_b_source(
    vleFluidType=sim.vleFluidType2,
    hFixed=4382e3,
    V_flowFixed=-20,
    boundaryType="p, m_flow",
    pFixed=pressureState2.pInitial,
    m_flowFixed=-0.06,
    streamVariablesInputType="h",
    TFixed=298.15)       annotation (Placement(transformation(extent={{56,-4},{
            64,16}}, rotation=0)));
  TIL.VLEFluidComponents.Boundaries.BoundaryUnderdetermined boundary_b_sink(
    vleFluidType=sim.vleFluidType2,
    streamVariablesInputType="h",
    TFixed=233.15)
    annotation (Placement(transformation(extent={{-100,-2},{-92,18}},rotation=0)));

  TIL.HeatExchangers.Plate.VLEFluidVLEFluid.ParallelFlowHX hx(
    nCells=3,
    pressureStateID_a=1,
    pressureStateID_b=2,
    redeclare model PressureDropModel_a =
        TIL.HeatExchangers.Plate.TransportPhenomena.PressureDrop.ZeroPressureDrop,
    redeclare model HeatTransferModel_b =
        TIL.HeatExchangers.Plate.TransportPhenomena.HeatTransfer.ConstantAlpha
        (constantAlpha=2000),
    redeclare model PressureDropModel_b =
        TIL.HeatExchangers.Plate.TransportPhenomena.PressureDrop.ZeroPressureDrop,
    vleFluidType_b=sim.vleFluidType2,
    redeclare model HeatTransferModel_a =
        TIL.HeatExchangers.Plate.TransportPhenomena.HeatTransfer.ConstantAlpha
        (constantAlpha=2000),
    redeclare model WallMaterial = TILMedia.SolidTypes.TILMedia_Aluminum,
    redeclare TIL.HeatExchangers.Plate.Geometry.Example hxGeometry(
      width=0.25,
      length=0.20,
      numberOfPlates=500),
    initVLEFluid_b="linearEnthalpyDistribution",
    hInitialVLEFluid_b_Cell1=4382e3,
    hInitialVLEFluid_b_CellN=3150e3,
    hInitialVLEFluid_a=199e3,
    initVLEFluid_a="linearEnthalpyDistribution",
    hInitialVLEFluid_a_Cell1=199e3,
    hInitialVLEFluid_a_CellN=499e3)
    annotation (Placement(transformation(extent={{-14,-28},{14,0}})));

  TIL.VLEFluidComponents.Sensors.StatePoint statePoint(stateViewerIndex=2,
      vleFluidType=sim.vleFluidType2)
    annotation (Placement(transformation(extent={{-48,20},{-40,28}})));
  TIL.VLEFluidComponents.Sensors.StatePoint statePoint1(stateViewerIndex=1,
      vleFluidType=sim.vleFluidType2)
    annotation (Placement(transformation(extent={{18,20},{26,28}})));
  TIL.VLEFluidComponents.Sensors.StatePoint statePoint2(stateViewerIndex=5)
    annotation (Placement(transformation(extent={{-52,-24},{-44,-16}})));
  TIL.VLEFluidComponents.Sensors.StatePoint statePoint3(stateViewerIndex=4)
    annotation (Placement(transformation(extent={{28,-24},{36,-16}})));
  TIL.VLEFluidComponents.Sensors.Sensor_T_degC sensor_T_degC(vleFluidType=sim.vleFluidType2)
    annotation (Placement(transformation(extent={{32,20},{40,28}})));
  TIL.VLEFluidComponents.Sensors.Sensor_T_degC sensor_T_degC1(vleFluidType=sim.vleFluidType2)
    annotation (Placement(transformation(extent={{-32,20},{-24,28}})));
  TIL.VLEFluidComponents.Sensors.Sensor_T_degC sensor_T_degC2
    annotation (Placement(transformation(extent={{-38,-24},{-30,-16}})));
  TIL.VLEFluidComponents.Sensors.Sensor_T_degC sensor_T_degC3
    annotation (Placement(transformation(extent={{42,-24},{50,-16}})));
  TIL.VLEFluidComponents.FillingStations.FillingStation fillingStation(
      vleFluidType=sim.vleFluidType2)
    annotation (Placement(transformation(extent={{-86,-14},{-78,10}})));
equation
  connect(boundary_a_source.port, pressureState1.portB)
                                              annotation (Line(
      points={{-80,-36},{-70,-36}},
      color={153,204,0},
      thickness=0.5));
  connect(boundary_b_source.port, pressureState2.portA) annotation (Line(
      points={{60,6},{54,6}},
      color={153,204,0},
      thickness=0.5,
      smooth=Smooth.None));
  connect(pressureState2.portB, hx.portB_b)             annotation (Line(
      points={{42,6},{20,6},{20,-6},{14,-6}},
      color={153,204,0},
      thickness=0.5,
      smooth=Smooth.None));
  connect(hx.portB_a, boundary_a_sink.port) annotation (Line(
      points={{14,-22},{20,-22},{20,-38},{58,-38}},
      color={153,204,0},
      thickness=0.5));
  connect(statePoint3.sensorPort, boundary_a_sink.port) annotation (Line(
      points={{32,-24},{32,-38},{58,-38}},
      color={153,204,0},
      thickness=0.5));
  connect(sensor_T_degC3.port, boundary_a_sink.port) annotation (Line(
      points={{46,-24},{46,-38},{58,-38}},
      color={153,204,0},
      thickness=0.5));
  connect(statePoint1.sensorPort, hx.portB_b) annotation (Line(
      points={{22,20},{22,6},{20,6},{20,-6},{14,-6}},
      color={153,204,0},
      thickness=0.5));
  connect(sensor_T_degC.port, hx.portB_b) annotation (Line(
      points={{36,20},{36,6},{20,6},{20,-6},{14,-6}},
      color={153,204,0},
      thickness=0.5));
  connect(sensor_T_degC1.port, hx.portA_b) annotation (Line(
      points={{-28,20},{-28,-6},{-14,-6},{-14,-6},{-14,-6}},
      color={153,204,0},
      thickness=0.5));
  connect(statePoint.sensorPort, hx.portA_b) annotation (Line(
      points={{-44,20},{-44,-6},{-18,-6},{-18,-6},{-14,-6}},
      color={153,204,0},
      thickness=0.5));
  connect(pressureState1.portA, hx.portA_a) annotation (Line(
      points={{-58,-36},{-20,-36},{-20,-22},{-14,-22}},
      color={153,204,0},
      thickness=0.5));
  connect(statePoint2.sensorPort, hx.portA_a) annotation (Line(
      points={{-48,-24},{-48,-36},{-20,-36},{-20,-22},{-14,-22}},
      color={153,204,0},
      thickness=0.5));
  connect(sensor_T_degC2.port, hx.portA_a) annotation (Line(
      points={{-34,-24},{-34,-36},{-20,-36},{-20,-22},{-14,-22}},
      color={153,204,0},
      thickness=0.5));
  connect(hx.portA_b, fillingStation.portB) annotation (Line(
      points={{-14,-6},{-22,-6},{-22,-6},{-30,-6},{-30,-6},{-70,-6},{-70,8},{
          -78,8}},
      color={153,204,0},
      thickness=0.5));
  connect(fillingStation.portA, boundary_b_sink.port) annotation (Line(
      points={{-86,8},{-96,8}},
      color={153,204,0},
      thickness=0.5));
  annotation (Diagram(coordinateSystem(
        preserveAspectRatio=true,
        extent={{-100,-60},{100,60}},
        initialScale=0.1)), uses(TIL(version="3.5.0"), TILMedia(version="3.5.0")));
end Model26042019_CO25bar;
